diff --git a/pgadmin/pgAdmin3.vcxproj.filters b/pgadmin/pgAdmin3.vcxproj.filters
index d18999d..d2dc0bf 100644
--- a/pgadmin/pgAdmin3.vcxproj.filters
+++ b/pgadmin/pgAdmin3.vcxproj.filters
@@ -1650,10 +1755,10 @@
       <Filter>include\hotdraw\utilities</Filter>
     </None>
     <None Include="schema\module.mk">
-      <Filter>include\schema</Filter>
+      <Filter>schema</Filter>
     </None>
     <None Include="slony\module.mk">
-      <Filter>include\slony</Filter>
+      <Filter>slony</Filter>
     </None>
     <None Include="ui\dlgAddFavourite.xrc">
       <Filter>ui</Filter>
@@ -1893,112 +1998,112 @@
       <Filter>ui</Filter>
     </None>
     <None Include="utils\module.mk">
-      <Filter>include\utils</Filter>
+      <Filter>utils</Filter>
     </None>
     <None Include="utils\tab-complete.inc">
-      <Filter>include\utils</Filter>
+      <Filter>utils</Filter>
     </None>
     <None Include="utils\tabcomplete.pl">
-      <Filter>include\utils</Filter>
+      <Filter>utils</Filter>
     </None>
     <None Include="gqb\module.mk">
-      <Filter>include\gqb</Filter>
+      <Filter>gqb</Filter>
     </None>
     <None Include="pgscript\module.mk">
-      <Filter>include\pgscript</Filter>
+      <Filter>pgscript</Filter>
     </None>
     <None Include="pgscript\parser.sh">
-      <Filter>include\pgscript</Filter>
+      <Filter>pgscript</Filter>
     </None>
     <None Include="pgscript\pgsParser.yy">
-      <Filter>include\pgscript</Filter>
+      <Filter>pgscript</Filter>
     </None>
     <None Include="pgscript\pgsScanner.ll">
-      <Filter>include\pgscript</Filter>
+      <Filter>pgscript</Filter>
     </None>
     <None Include="pgscript\README">
-      <Filter>include\pgscript</Filter>
+      <Filter>pgscript</Filter>
     </None>
     <None Include="pgscript\exceptions\module.mk">
-      <Filter>include\pgscript\exceptions</Filter>
+      <Filter>pgscript\exceptions</Filter>
     </None>
     <None Include="pgscript\expressions\module.mk">
-      <Filter>include\pgscript\expressions</Filter>
+      <Filter>pgscript\expressions</Filter>
     </None>
     <None Include="pgscript\generators\module.mk">
-      <Filter>include\pgscript\generators</Filter>
+      <Filter>pgscript\generators</Filter>
     </None>
     <None Include="pgscript\objects\module.mk">
-      <Filter>include\pgscript\objects</Filter>
+      <Filter>pgscript\objects</Filter>
     </None>
     <None Include="pgscript\statements\module.mk">
-      <Filter>include\pgscript\statements</Filter>
+      <Filter>pgscript\statements</Filter>
     </None>
     <None Include="pgscript\utilities\module.mk">
-      <Filter>include\pgscript\utilities</Filter>
+      <Filter>pgscript\utilities</Filter>
     </None>
     <None Include="pgscript\utilities\m_apm\module.mk">
-      <Filter>include\pgscript\utilities\m_apm</Filter>
+      <Filter>pgscript\utilities\m_apm</Filter>
     </None>
     <None Include="ogl\module.mk">
-      <Filter>include\ogl</Filter>
+      <Filter>ogl</Filter>
     </None>
     <None Include="ogl\README">
-      <Filter>include\ogl</Filter>
+      <Filter>ogl</Filter>
     </None>
     <None Include="dd\module.mk">
-      <Filter>include\dd</Filter>
+      <Filter>dd</Filter>
     </None>
     <None Include="dd\dditems\module.mk">
-      <Filter>include\dd\dditems</Filter>
+      <Filter>dd\dditems</Filter>
     </None>
     <None Include="dd\dditems\figures\module.mk">
-      <Filter>include\dd\dditems\figures</Filter>
+      <Filter>dd\dditems\figures</Filter>
     </None>
     <None Include="dd\dditems\handles\module.mk">
-      <Filter>include\dd\dditems\handles</Filter>
+      <Filter>dd\dditems\handles</Filter>
     </None>
     <None Include="dd\dditems\locators\module.mk">
-      <Filter>include\dd\dditems\locators</Filter>
+      <Filter>dd\dditems\locators</Filter>
     </None>
     <None Include="dd\dditems\tools\module.mk">
-      <Filter>include\dd\dditems\tools</Filter>
+      <Filter>dd\dditems\tools</Filter>
     </None>
     <None Include="dd\dditems\utilities\module.mk">
-      <Filter>include\dd\dditems\utilities</Filter>
+      <Filter>dd\dditems\utilities</Filter>
     </None>
     <None Include="dd\ddmodel\module.mk">
-      <Filter>include\dd\ddmodel</Filter>
+      <Filter>dd\ddmodel</Filter>
     </None>
     <None Include="hotdraw\module.mk">
-      <Filter>include\hotdraw</Filter>
+      <Filter>hotdraw</Filter>
     </None>
     <None Include="hotdraw\connectors\module.mk">
-      <Filter>include\hotdraw\connectors</Filter>
+      <Filter>hotdraw\connectors</Filter>
     </None>
     <None Include="hotdraw\figures\module.mk">
-      <Filter>include\hotdraw\figures</Filter>
+      <Filter>hotdraw\figures</Filter>
     </None>
     <None Include="hotdraw\figures\defaultAttributes\module.mk">
-      <Filter>include\hotdraw\figures\defaultAttributes</Filter>
+      <Filter>hotdraw\figures\defaultAttributes</Filter>
     </None>
     <None Include="hotdraw\figures\xml\module.mk">
-      <Filter>include\hotdraw\figures\xml</Filter>
+      <Filter>hotdraw\figures\xml</Filter>
     </None>
     <None Include="hotdraw\handles\module.mk">
-      <Filter>include\hotdraw\handles</Filter>
+      <Filter>hotdraw\handles</Filter>
     </None>
     <None Include="hotdraw\locators\module.mk">
-      <Filter>include\hotdraw\locators</Filter>
+      <Filter>hotdraw\locators</Filter>
     </None>
     <None Include="hotdraw\main\module.mk">
-      <Filter>include\hotdraw\main</Filter>
+      <Filter>hotdraw\main</Filter>
     </None>
     <None Include="hotdraw\tools\module.mk">
-      <Filter>include\hotdraw\tools</Filter>
+      <Filter>hotdraw\tools</Filter>
     </None>
     <None Include="hotdraw\utilities\module.mk">
-      <Filter>include\hotdraw\utilities</Filter>
+      <Filter>hotdraw\utilities</Filter>
     </None>
     <None Include="Makefile.am" />
     <None Include="plugins.ini" />
@@ -3311,6 +3416,9 @@
     <ClInclude Include="include\hotdraw\utilities\hdRemoveDeleteDialog.h">
       <Filter>include\hotdraw\utilities</Filter>
     </ClInclude>
+    <ClInclude Include="include\utils\sshTunnel.h">
+      <Filter>include\utils</Filter>
+    </ClInclude>
   </ItemGroup>
   <ItemGroup>
     <png2c Include="include\images\aggregate-sm.png">
diff --git a/pgadmin/precomp.cpp b/pgadmin/precomp.cpp
index 58d2abb..edee794 100644
--- a/pgadmin/precomp.cpp
+++ b/pgadmin/precomp.cpp
@@ -9,6 +9,10 @@
 //
 //////////////////////////////////////////////////////////////////////////
 
+#ifdef WIN32
+#define WIN32_LEAN_AND_MEAN
+#endif
+
 #include <wx/wxprec.h>
 
 #include "pgAdmin3.h"
diff --git a/pgadmin/schema/pgServer.cpp b/pgadmin/schema/pgServer.cpp
index 28b5308..8df57ea 100644
--- a/pgadmin/schema/pgServer.cpp
+++ b/pgadmin/schema/pgServer.cpp
@@ -37,10 +37,14 @@
 #include "utils/registry.h"
 #include "frm/frmReport.h"
 #include "dlg/dlgServer.h"
+#include "utils/sshTunnel.h"
 
 #define DEFAULT_PG_DATABASE wxT("postgres")
 
-pgServer::pgServer(const wxString &newName, const wxString &newHostAddr, const wxString &newDescription, const wxString &newService, const wxString &newDatabase, const wxString &newUsername, int newPort, bool _storePwd, const wxString &newRolename, bool _restore, int _ssl, const wxString &_colour, const wxString &_group)
+pgServer::pgServer(const wxString &newName, const wxString &newHostAddr, const wxString &newDescription, const wxString &newService,
+	const wxString &newDatabase, const wxString &newUsername, int newPort, bool _storePwd, const wxString &newRolename, bool _restore,
+	int _ssl, const wxString &_colour, const wxString &_group, bool _sshTunnel, const wxString &newTunnelHost, const wxString &newTunnelUserName,
+	bool _authModePwd, const wxString &newTunnelPassword, const wxString &newPublicKey, const wxString &newIdentity)
 	: pgObject(serverFactory, newName)
 {
 	description = newDescription;
@@ -65,6 +69,17 @@ pgServer::pgServer(const wxString &newName, const wxString &newHostAddr, const w
 	restore = _restore;
 	superUser = false;
 	createPrivilege = false;
+
+	// SSH Tunnel
+	tunnelObj = NULL;
+	sshTunnel = _sshTunnel;
+	tunnelHost = newTunnelHost;
+	tunnelUserName = newTunnelUserName;
+	authModePwd = _authModePwd;
+	tunnelPassword = newTunnelPassword;
+	publicKeyFile = newPublicKey;
+	identityFile = newIdentity;
+
 #ifdef WIN32
 	scmHandle = 0;
 	serviceHandle = 0;
@@ -76,6 +91,12 @@ pgServer::~pgServer()
 	if (conn)
 		delete conn;
 
+	if(tunnelObj)
+	{
+		delete tunnelObj;
+		tunnelObj = NULL;
+	}
+
 #ifdef WIN32
 	if (serviceHandle)
 		CloseServiceHandle(serviceHandle);
@@ -188,7 +209,16 @@ pgConn *pgServer::CreateConn(wxString dbName, OID oid, wxString applicationname)
 		dbName = GetDatabaseName();
 		oid = dbOid;
 	}
-	pgConn *conn = new pgConn(GetName(), service, hostaddr, dbName, username, password, port, rolename, ssl, oid, applicationname, sslcert, sslkey, sslrootcert, sslcrl, sslcompression);
+
+	pgConn *conn = NULL;
+	if(sshTunnel)
+	{
+		conn = new pgConn(local_listenhost, service, hostaddr, dbName, username, password, local_listenport, rolename, ssl, oid, applicationname, sslcert, sslkey, sslrootcert, sslcrl, sslcompression);
+	}
+	else
+	{
+		conn = new pgConn(GetName(), service, hostaddr, dbName, username, password, port, rolename, ssl, oid, applicationname, sslcert, sslkey, sslrootcert, sslcrl, sslcompression);
+	}
 
 	if (conn && conn->GetStatus() != PGCONN_OK)
 	{
@@ -666,23 +696,46 @@ int pgServer::Connect(frmMain *form, bool askPassword, const wxString &pwd, bool
 
 		form->StartMsg(_("Connecting to database"));
 
+		wxString host;
+		int iPort;
+		if(sshTunnel)
+		{
+			// Create SSH Tunnel if required
+			if(!tunnelObj)
+			{
+				if(!createSSHTunnel())
+				{
+					form->EndMsg(false);
+					return PGCONN_BAD;
+				}
+			}
+
+			host = local_listenhost;
+			iPort = local_listenport;
+		}
+		else
+		{
+			host = GetName();
+			iPort = port;
+		}
+
 		if (database.IsEmpty())
 		{
-			conn = new pgConn(GetName(), service, hostaddr, DEFAULT_PG_DATABASE, username, password, port, rolename, ssl, 0, appearanceFactory->GetLongAppName() + _(" - Browser"), sslcert, sslkey, sslrootcert, sslcrl, sslcompression);
+			conn = new pgConn(host, service, hostaddr, DEFAULT_PG_DATABASE, username, password, iPort, rolename, ssl, 0, appearanceFactory->GetLongAppName() + _(" - Browser"), sslcert, sslkey, sslrootcert, sslcrl, sslcompression);
 			if (conn->GetStatus() == PGCONN_OK)
 				database = DEFAULT_PG_DATABASE;
 			else if (conn->GetStatus() == PGCONN_BAD && conn->GetLastError().Find(
 			             wxT("database \"") DEFAULT_PG_DATABASE wxT("\" does not exist")) >= 0)
 			{
 				delete conn;
-				conn = new pgConn(GetName(), service, hostaddr, wxT("template1"), username, password, port, rolename, ssl, 0, appearanceFactory->GetLongAppName() + _(" - Browser"), sslcert, sslkey, sslrootcert, sslcrl, sslcompression);
+				conn = new pgConn(host, service, hostaddr, wxT("template1"), username, password, iPort, rolename, ssl, 0, appearanceFactory->GetLongAppName() + _(" - Browser"), sslcert, sslkey, sslrootcert, sslcrl, sslcompression);
 				if (conn && conn->GetStatus() == PGCONN_OK)
 					database = wxT("template1");
 			}
 		}
 		else
 		{
-			conn = new pgConn(GetName(), service, hostaddr, database, username, password, port, rolename, ssl, 0, appearanceFactory->GetLongAppName() + _(" - Browser"), sslcert, sslkey, sslrootcert, sslcrl, sslcompression);
+			conn = new pgConn(host, service, hostaddr, database, username, password, iPort, rolename, ssl, 0, appearanceFactory->GetLongAppName() + _(" - Browser"), sslcert, sslkey, sslrootcert, sslcrl, sslcompression);
 			if (!conn)
 			{
 				form->EndMsg(false);
@@ -1216,6 +1269,47 @@ bool pgServer::AddNamedRestorePoint()
 	return false;
 }
 
+bool pgServer::createSSHTunnel()
+{
+	bool retVal = false;
+
+	tunnelObj = new CSSHTunnelThread(tunnelHost, GetName(), port, tunnelUserName, tunnelPassword, publicKeyFile,
+		identityFile, authModePwd ? AUTH_PASSWORD : AUTH_PUBLICKEY);
+
+	if(tunnelObj)
+	{
+		if(tunnelObj->Initialize())
+		{
+			if ( tunnelObj->Create() != wxTHREAD_NO_ERROR )
+			{
+				delete tunnelObj;
+				tunnelObj = NULL;
+				wxLogError(_("SSH Error: Unable to create SSH Tunnling Thread"));
+			}
+			else
+			{
+				if (tunnelObj->Run() != wxTHREAD_NO_ERROR )
+				{
+					delete tunnelObj;
+					tunnelObj = NULL;
+					wxLogError(_("SSH Error: Unable to start SSH Tunnling Thread"));
+				}
+
+				SetLocalListenHost(tunnelObj->GetLocalListenIP());
+				SetLocalListenPort(tunnelObj->GetLocalListenPort());
+				retVal = true;
+			}
+		}
+		else
+		{
+			delete tunnelObj;
+			tunnelObj = NULL;
+		}
+	}
+
+	return retVal;
+}
+
 
 pgServerCollection::pgServerCollection(pgaFactory *factory)
 	: pgCollection(factory)
@@ -1289,6 +1383,7 @@ pgObject *pgServerFactory::CreateObjects(pgCollection *obj, ctlTree *browser, co
 	wxString key, servername, hostaddr, description, service, database, username, lastDatabase, lastSchema;
 	wxString storePwd, rolename, restore, serviceID, discoveryID, dbRestriction, colour;
 	wxString group, sslcert, sslkey, sslrootcert, sslcrl, sslcompression;
+	wxString sshTunnel, authModePwd, tunnelHost, tunnelUserName, tunnelPassword, publicKeyFile, identityFile;
 	pgServer *server = 0;
 
 	wxArrayString discoveredServers;
@@ -1327,6 +1422,13 @@ pgObject *pgServerFactory::CreateObjects(pgCollection *obj, ctlTree *browser, co
 		settings->Read(key + wxT("SSLRootCert"), &sslrootcert, wxEmptyString);
 		settings->Read(key + wxT("SSLCrl"), &sslcrl, wxEmptyString);
 		settings->Read(key + wxT("SSLCompression"), &sslcompression, wxT("true"));
+		settings->Read(key + wxT("SSHTunnel"), &sshTunnel, wxT("false"));
+		settings->Read(key + wxT("TunnelHost"), &tunnelHost, wxEmptyString);
+		settings->Read(key + wxT("TunnelUserName"), &tunnelUserName, wxEmptyString);
+		settings->Read(key + wxT("TunnelModePwd"), &authModePwd, wxT("true"));
+		settings->Read(key + wxT("TunnelPassword"), &tunnelPassword, wxEmptyString);
+		settings->Read(key + wxT("PublicKeyFile"), &publicKeyFile, wxEmptyString);
+		settings->Read(key + wxT("IdentityFile"), &identityFile, wxEmptyString);
 
 		// Sanitize the colour
 		colour = colour.Trim();
@@ -1361,7 +1463,8 @@ pgObject *pgServerFactory::CreateObjects(pgCollection *obj, ctlTree *browser, co
 		}
 
 		// Add the Server node
-		server = new pgServer(servername, hostaddr, description, service, database, username, port, StrToBool(storePwd), rolename, StrToBool(restore), ssl);
+		server = new pgServer(servername, hostaddr, description, service, database, username, port, StrToBool(storePwd), rolename, StrToBool(restore), ssl,
+			colour, group, StrToBool(sshTunnel), tunnelHost, tunnelUserName, StrToBool(authModePwd), tunnelPassword, publicKeyFile, identityFile);
 		server->iSetLastDatabase(lastDatabase);
 		server->iSetLastSchema(lastSchema);
 		server->iSetService(service);
@@ -1369,8 +1472,6 @@ pgObject *pgServerFactory::CreateObjects(pgCollection *obj, ctlTree *browser, co
 		server->iSetDiscoveryID(discoveryID);
 		server->iSetDiscovered(false);
 		server->iSetDbRestriction(dbRestriction);
-		server->iSetColour(colour);
-		server->iSetGroup(group);
 		server->iSetServerIndex(loop);
 		server->SetSSLCert(sslcert);
 		server->SetSSLKey(sslkey);
@@ -1378,6 +1479,7 @@ pgObject *pgServerFactory::CreateObjects(pgCollection *obj, ctlTree *browser, co
 		server->SetSSLCrl(sslcrl);
 		server->iSetSSLCompression(StrToBool(sslcompression));
 
+
 		found = false;
 		if (browser->ItemHasChildren(obj->GetId()))
 		{
@@ -1992,4 +2094,4 @@ bool addnamedrestorepointServiceFactory::CheckEnable(pgObject *obj)
 		return server->GetConnected() && server->connection()->BackendMinimumVersion(9, 1) && !server->GetInRecovery();
 	}
 	return false;
-}
+}
\ No newline at end of file
diff --git a/pgadmin/ui/dlgServer.xrc b/pgadmin/ui/dlgServer.xrc
index c0bbd77..60f5ef5 100644
--- a/pgadmin/ui/dlgServer.xrc
+++ b/pgadmin/ui/dlgServer.xrc
@@ -257,6 +257,130 @@
             </object>
           </object>
           <object class="notebookpage">
+            <label>SSH Tunnel</label>
+            <object class="wxPanel" name="pnlSSH">
+              <object class="wxFlexGridSizer">
+                <cols>2</cols>
+                <vgap>5</vgap>
+                <hgap>5</hgap>
+                <growablecols>1</growablecols>
+                <object class="sizeritem">
+                  <object class="wxStaticText" name="stSSHTunnel">
+                    <label>Use SSH tunneling</label>
+                  </object>
+                  <flag>wxALIGN_CENTRE_VERTICAL|wxTOP|wxLEFT|wxRIGHT</flag>
+                  <border>4</border>
+                </object>
+                <object class="sizeritem">
+                  <object class="wxCheckBox" name="chkSSHTunnel">
+                    <label></label>
+                    <checked>0</checked>
+                  </object>
+                  <flag>wxEXPAND|wxALIGN_CENTRE_VERTICAL|wxTOP|wxLEFT|wxRIGHT</flag>
+                  <border>4</border>
+                </object>
+                <object class="sizeritem">
+                  <object class="wxStaticText" name="stTunnelHost">
+                    <label>Tunnel host</label>
+                  </object>
+                  <flag>wxALIGN_CENTRE_VERTICAL|wxTOP|wxLEFT|wxRIGHT</flag>
+                  <border>4</border>
+                </object>
+                <object class="sizeritem">
+                  <object class="wxTextCtrl" name="txtTunnelHost"/>
+                  <flag>wxEXPAND|wxALIGN_CENTRE_VERTICAL|wxTOP|wxLEFT|wxRIGHT</flag>
+                  <border>4</border>
+                </object>
+                <object class="sizeritem">
+                  <object class="wxStaticText" name="stTunnelUsername">
+                    <label>Username</label>
+                  </object>
+                  <flag>wxALIGN_CENTRE_VERTICAL|wxTOP|wxLEFT|wxRIGHT</flag>
+                  <border>4</border>
+                </object>
+                <object class="sizeritem">
+                  <object class="wxTextCtrl" name="txtTunnelUsername"/>
+                  <flag>wxEXPAND|wxALIGN_CENTRE_VERTICAL|wxTOP|wxLEFT|wxRIGHT</flag>
+                  <border>4</border>
+                </object>
+                <object class="sizeritem">
+                  <object class="wxStaticText" name="stAuthentication">
+                    <label>Authentication</label>
+                  </object>
+                  <flag>wxALIGN_CENTRE_VERTICAL|wxTOP|wxLEFT|wxRIGHT</flag>
+                  <border>4</border>
+                </object>
+                <object class="sizeritem">
+                  <object class="wxFlexGridSizer">
+                    <cols>2</cols>
+                    <vgap>10</vgap>
+                    <hgap>10</hgap>
+                    <growablecols>1</growablecols>
+                    <object class="sizeritem">
+                      <object class="wxRadioButton" name="radioBtnPassword">
+                        <label>Password</label>
+                        <style>wxRB_GROUP</style>
+                      </object>
+                      <flag>wxEXPAND|wxALIGN_CENTER_VERTICAL</flag>
+                    </object>
+                    <object class="sizeritem">
+                      <object class="wxRadioButton" name="radioBtnKeyfile">
+                        <label>Identity file</label>
+                      </object>
+                      <flag>wxEXPAND|wxALIGN_CENTER_VERTICAL</flag>
+                    </object>
+                  </object>
+                  <flag>wxALIGN_CENTRE_VERTICAL|wxTOP|wxLEFT|wxRIGHT</flag>
+                  <border>4</border>
+                </object>
+                <object class="sizeritem">
+                  <object class="wxStaticText" name="stIdentityFile">
+                    <label>Identity file</label>
+                  </object>
+                  <flag>wxALIGN_CENTRE_VERTICAL|wxTOP|wxLEFT|wxRIGHT</flag>
+                  <border>4</border>
+                </object>
+                <object class="sizeritem">
+                  <object class="wxFilePickerCtrl" name="pickerIdentityFile">
+                    <message>Select identity file</message>
+                    <wildcard>*</wildcard>
+                  </object>
+                  <flag>wxEXPAND|wxALIGN_CENTER_VERTICAL|wxTOP|wxLEFT|wxRIGHT</flag>
+                  <border>4</border>
+                </object>
+                <object class="sizeritem">
+                  <object class="wxStaticText" name="stPublicKeyFile">
+                    <label>Public key</label>
+                  </object>
+                  <flag>wxALIGN_CENTRE_VERTICAL|wxTOP|wxLEFT|wxRIGHT</flag>
+                  <border>4</border>
+                </object>
+                <object class="sizeritem">
+                  <object class="wxFilePickerCtrl" name="pickerPublicKeyFile">
+                    <message>Select public key file</message>
+                    <wildcard>*.pub</wildcard>
+                  </object>
+                  <flag>wxEXPAND|wxALIGN_CENTER_VERTICAL|wxTOP|wxLEFT|wxRIGHT</flag>
+                  <border>4</border>
+                </object>
+                <object class="sizeritem">
+                  <object class="wxStaticText" name="stTunnelPassword">
+                    <label>Password/Passphrase</label>
+                  </object>
+                  <flag>wxALIGN_CENTRE_VERTICAL|wxTOP|wxLEFT|wxRIGHT</flag>
+                  <border>4</border>
+                </object>
+                <object class="sizeritem">
+                  <object class="wxTextCtrl" name="txtTunnelPassword">
+                    <style>wxTE_PASSWORD</style>
+                  </object>
+                  <flag>wxEXPAND|wxALIGN_CENTRE_VERTICAL|wxTOP|wxLEFT|wxRIGHT</flag>
+                  <border>4</border>
+                </object>
+              </object>
+            </object>
+          </object>
+          <object class="notebookpage">
             <label>Advanced</label>
             <object class="wxPanel" name="pnlOptional">
               <object class="wxFlexGridSizer">
diff --git a/pgadmin/utils/module.mk b/pgadmin/utils/module.mk
index 350aaa6..b01d295 100644
--- a/pgadmin/utils/module.mk
+++ b/pgadmin/utils/module.mk
@@ -21,7 +21,8 @@ pgadmin3_SOURCES += \
 	$(srcdir)/utils/sysSettings.cpp \
 	$(srcdir)/utils/tabcomplete.c \
 	$(srcdir)/utils/utffile.cpp \
-	$(srcdir)/utils/macros.cpp
+	$(srcdir)/utils/macros.cpp \
+	$(srcdir)/utils/sshTunnel.cpp
 
 EXTRA_DIST += \
 	$(srcdir)/utils/module.mk \
